unit ini;
interface
var inipath:string;

procedure createini(clear_if_exist:boolean);
procedure writeini(group,rec,value:string);
function readini(group,rec:string):string;
function inwhatline(group,rec:string):integer;
procedure deleteini(group,rec:string);

implementation
uses sysutils,dialogs;

function empty(toempty:string):string;
var temp:string;
    x:byte;
begin
  temp:='';
  for x:=1 to length(toempty) do
    if toempty[x]<>' ' then temp:=temp+toempty[x];
  empty:=temp;
end;

function readini(group,rec:string):string;
var readed,now:string;
    f:textfile;
    x:integer;
begin
  createini(False);  //Creates INI file, if it does not exists...
  assignfile(f,inipath);
  reset(f);
  now:='';
  repeat
    readln(f,readed);
    readed:=ansiuppercase(readed);
    if empty(readed)='['+ansiuppercase(group)+']' then
    begin
      repeat
        readln(f,readed);
        if copy(empty(ansiuppercase(readed)),1,length(rec))=ansiuppercase(rec) then
          for x:=1 to length(readed) do
            if readed[x]= '=' then
              now:=copy(readed,x+1,length(readed)-x);
      until (empty(readed)[1]='[') or (now<>'') or (eof(f));
    end;
  until (now<>'') or (eof(f));
  closefile(f);
  readini:=now;
end;

function inwhatline(group,rec:string):integer;
var readed:string;
    f:textfile;
    x,now:integer;
begin
  createini(False);  //Creates INI file, if it does not exists...
  assignfile(f,inipath);
  reset(f);
  x:=0;
  now:=0;
  repeat
    x:=x+1;
    readln(f,readed);
    readed:=ansiuppercase(readed);
    if empty(readed)='['+ansiuppercase(group)+']' then
    begin
      repeat
        x:=x+1;
        readln(f,readed);
        readed:=ansiuppercase(readed);
        if copy(empty(readed),1,length(rec))=ansiuppercase(rec) then
          now:=x;
      until (empty(readed)[1]='[') or (now<>0) or (eof(f));
    end;
  until (now<>0) or (eof(f));
  closefile(f);
  inwhatline:=now;
end;

procedure writeini(group,rec,value:string);
var readed:string;
    f,f1:textfile;
    x,now:integer;
    rewriteln:boolean;
begin
  createini(False);  //Creates INI file, if it does not exists...
  now:=inwhatline(group,rec);
  rewriteln:=true;
  if now=0 then
  begin
    assignfile(f,inipath);
    reset(f);
    x:=0;
    repeat
      x:=x+1;
      readln(f,readed);
      readed:=ansiuppercase(readed);
      if empty(readed)='['+ansiuppercase(group)+']' then
        now:=x+1;
    until (eof(f)) or (now<>0);
    closefile(f);
    rewriteln:=false;
  end;

  if now=0 then
  begin
    assign(f,inipath);
    append(f);
    writeln(f,'');
    writeln(f,'['+group+']');
    writeln(f,rec+'='+value);
    closefile(f);
  end else begin
    deletefile(inipath+'.tmp');
    renamefile(inipath,inipath+'.tmp');

    assignfile(f,inipath+'.tmp');
    assignfile(f1,inipath);

    reset(f);
    rewrite(f1);

    x:=0;
    repeat
      x:=x+1;
      if rewriteln then
        readln(f,readed)
      else
        if x<>now then readln(f,readed);
      if x=now then
        writeln(f1,rec+'='+value)
      else
        writeln(f1,readed);
    until eof(f);
    closefile(f);
    closefile(f1);
    deletefile(inipath+'.tmp');
  end;

end;

procedure createini(clear_if_exist:boolean);
var f:file;
begin
  assign(f,inipath);
  if clear_if_exist then
  begin
    rewrite(f,1);
    closefile(f);
  end;
  assign(f,inipath);
  if not fileexists(inipath) then
  begin
    rewrite(f,1);
    closefile(f);
  end;

end;

procedure deleteini(group,rec:string);
var x,now:integer;
    f,f1:textfile;
    readed:string;
begin
  createini(False);  //Creates INI file, if it does not exists...
  if rec<>'' then    //If record must be deleted
  begin
    now:=inwhatline(group,rec);
    deletefile(inipath+'.tmp');
    renamefile(inipath,inipath+'.tmp');

    assignfile(f,inipath+'.tmp');
    assignfile(f1,inipath);

    reset(f);
    rewrite(f1);

    x:=0;
    repeat
      x:=x+1;
      readln(f,readed);
      if now<>x then writeln(f1,readed)
    until eof(f);
    closefile(f);
    closefile(f1);
    deletefile(inipath+'.tmp');
  end else begin
    deletefile(inipath+'.tmp');
    renamefile(inipath,inipath+'.tmp');

    assignfile(f,inipath+'.tmp');
    assignfile(f1,inipath);

    reset(f);
    rewrite(f1);

    repeat
      readln(f,readed);
      if empty(ansiuppercase(readed))='['+ansiuppercase(group)+']' then
        repeat
          readln(f,readed);
        until (empty(readed)[1]='[') or (eof(f))
      else
        writeln(f1,readed);
    until eof(f);
    closefile(f);
    closefile(f1);
  end;
end;

function progdir:string;
var x,last:byte;
begin
  last:=0;
  for x:=1 to length(paramstr(0)) do
    if paramstr(0)[x]='\' then last:=x;
  progdir:=copy(paramstr(0),1,last);
end;

begin
  inipath:=progdir+'main.ini';
end.
